st7/
;Program demonstracyjny demonstrujacy uzycie
;wyswietlacza LED: 6 znakw 7 segmentowych

	MOTOROLA			;format MOTOROLA (.s19)

	#include "st7flite29.inc"

;segmenty pamieci
	BYTES
	segment byte at 80-FF 'ram0'
	segment byte at 100-1FF 'stack'
	segment byte at 200-27F 'ram1'
	segment byte at 1000-10FF 'eeprom'
	segment byte at E000-FFDF 'program'
	segment byte at FFE0-FFFF 'intvect'



	BYTES
;deklaracje zmiennych
	segment 'ram0'
ledcnt	DS.B		;licznik znakw LED
ledbuf	DS.B	6	;miejsce na 6 znakw
leddata	DS.B	2	;biezacy wyswietlany znak
vvolts	DS.B	2	;bufor na wynik pomiaru
decims	DS.B	6	;bufor dla konwersji BCD
roznicaw	DS.B	2	;dla funkcji odejmujacej
sub_a	DS.B	2
sub_b	DS.B	2

;deklaracje stalych
	WORDS
	segment 'program'

;-------------------------------------------------------
; deklaracje tabel zwiazanych z cyframi
;-------------------------------------------------------
sequence	DC.B	$FE,$FD,$FB,$F7,$EF,$DF
patterns	DC.B	%00001001,%10101111,%00011010,%10001010,%10101100,	;0,1,2,3,4,
pat1	DC.B	%11001000,%01001000,%10001111,%00001000,%10001000,	;5,6,7,8,9,
pat2	DC.B	$FF						;znak wylaczony


;-------------------------------------------------------
; inicjacja uzywanych portw I/O
;port B
PBDR_init	EQU	%00000000
PBDDR_init	EQU	%11111011
PBOR_init	EQU	%11111011
;-------------------------------------------------------
PORTS_INIT MACRO
	ld	A,#PBDDR_init	;nastawa trybu pracy portu B
	ld	PBDDR,A
	ld	A,#PBOR_init
	ld	PBOR,A
	ld       A,#PBDR_init
	ld	PBDR,A
	MEND


;-------------------------------------------------------
; inicjacja SPI:
;   CLK = fcpu/3, divider = wylaczony, cpol = idle gdy "H",
;   cpha = 1, przrwania = wylaczone, tryb = master
SPISR_init	EQU	%00000011
SPICR_init	EQU	%00011100
SPI_enable	EQU	%01000000
;-------------------------------------------------------
SPI_INIT	MACRO
	ld	A,#SPISR_init
	ld	SPISR,A
	ld	A,#SPICR_init
	ld	SPICR,A
	or	A,#SPI_enable
	ld	SPICR,A
	MEND


;-------------------------------------------------------
; inicjacja timera Lite (timer B)
;-------------------------------------------------------
TIMB_INIT MACRO
	clr	A		;f_CPU = f_OSC
	ld	MCCSR,A
	ld	A,#$12		;f_TIMER = f_CPU
	ld	ATCSR,A
        	clr	A		;konfiguracja 12-bitowego timera
	ld	ATRL,A
	ld	A,#$07
	ld	ATRH,A
	clr	ledcnt		;zerowanie licznika znakow
	MEND


;-------------------------------------------------------
; funkcja obslugi przerwania timera B
;-------------------------------------------------------
timerb
	ld	A,ledcnt
	sub	A,#6		;C=1 dla licznika <= 6
	jrc	timbskip
	clr	ledcnt		;jesli licznik > 5,to zerowanie
timbskip
	ld	X,ledcnt		;zaladowanie wzorca zalaczenia klucza tranzystorowego
	ld	A,(sequence,X)	;na podstawie wartosci licznika
	ld	leddata,A
	ld	A,(ledbuf,X)	;pobranie cyfry BCD do akumulatora
	ld	X,A		;ustawienie rejestru indeksowego
	ld	A,(patterns,X)	;pobranie wzorca cyfry
	ld	{leddata+1},A	;zaladowanie wzorca cyfry do bufora biezacej cyfry
	call	ledwrite		;wyslanie znakow do rejestrow cyfr
	inc	ledcnt
	ld	A,ATCSR		;odczyt ATCSR w celu zerowania flagi przerwania
	iret


;-------------------------------------------------------
; funkcja wysylajaca slowo LEDDATA do wyswietlacza
;-------------------------------------------------------
ledwrite
	push	X		;zapamietanie modyfikowanych rejestrw
	push	A
	clr	X
	ld	A,(leddata,X)	;pierwszy bajt slowa
	ld	SPIDR,A
	btjf	SPISR,#7,*	;oczekiwanie na wyslanie bajtu
	ld	A,SPIDR		;dla wyzerowania SPIF
	inc	X		;drugi bajt slowa
	ld	A,(leddata,X)
	ld	SPIDR,A
	btjf	SPISR,#7,*	;oczekiwanie na wyslanie bajtu
	ld	A,SPIDR		;dla wyzerowania SPIF
	ld	A,PBDR		;krki impuls dodatni na PB4
	or	A,#$10
	ld	PBDR,A
	and	A,#$EF
	ld	PBDR,A
	pop	A		;odtworzenie rejestrw
	pop	X
	ret


;-------------------------------------------------------
;pomiar napiecia (wartosc zmierzona w komorce VVOLTS
;-------------------------------------------------------
volts
	clr	ADCCSR		;inicjacja rejestru kontrolnego, wylaczenie przetwornika
	clr	ADCDRL		;nastawa rejestru czasu pomiaru i wzmacniacza wejsciowego
	ld	A,#$40		;ustawienie szybkosc przetwarzania (SPEED=1)
	ld	ADCCSR,A
	ld	A,ADCDRH		;kasowanie flagi EOC
	ld	A,#$04
	ld	ADCCSR,A		;zalaczenie kanalu pomiarowego AIN4
	or	A,#$20		;uruchomienie pomiaru
	ld	ADCCSR,A
	btjf	ADCCSR,#7,*	;oczekiwanie na zakonczenie pomiaru
	clr	vvolts		;kompozycja starszego bajtu wyniku
	ld	X,vvolts		;ustawienie dwch  najmlodszych bitw przez przesuniecie z flaga C
	ld	A,ADCDRH
	sll	A
	rlc	X
	sll	A
	rlc	X
	ld	vvolts,X		;zapamietanie starszego bajtu
	ld	{vvolts+1},A	;kompozycja mlodszego bajtu suma z dwoma mlodszymi bitami z ADCDRL
	ld	A,ADCDRL
	and	A,#$03		;maskowanie nieznaczacych bitw
	or	A,{vvolts+1}	;sumowanie D0 i D1 wyniku
	ld	{vvolts+1},A	;zapamietanie wyniku pomiaru
;obliczenia dla napiecia Uref=5V
;Ux = Uref x vvolts = 5 x vvolts
	ld	A,{vvolts+1}	;mlodszy bajt wyniku pomiaru
	ld	X,vvolts		;starszy bajt wyniku pomiaru
	sll	A		;mnozenie x4 (2 przesuniecia w lewo)
	rlc	X
	sll	A
	rlc	X
	ld	{sub_a+1},A	;zapamietanie liczby po mnozeniu x 4
	ld	sub_a,X		;w zmiennej SUB_A
	ld	A,{vvolts+1}	;dodawanie: 4vvolts + vvolts
	add	A,{sub_a+1}
	ld	{vvolts+1},A
	ld	A,vvolts
	adc	A,sub_a
	ld	vvolts,A
	ret


;-------------------------------------------------------
; odejmowanie liczb 2-bajtowych
;-------------------------------------------------------
subw
	push	A		;zapamietanie rejestrw roboczych
	push	X
	ld	A,{sub_a+1} 	;pobranie mlodszego liczby a
	sub 	A,{sub_b+1} 	;dodanie mlodszego liczby b
	ld 	{roznicaw+1},A 	;zapamietanie mlodszego bajtu roznicy
	ld 	A,sub_a 		;pobranie starszego bajtu liczby a
	sbc 	A,sub_b 		;odjecie przeniesienia i starszego bajtu liczby b
	ld 	roznicaw,A 	;zapamietanie starszego bajtu roznicy
	pop 	X 		;odtworzenie rejestrw
	pop 	A
	ret

;-------------------------------------------------------
;konwersja na liczbe dziesietna; poszczegolne wagi
;umieszczone w komorkach tablicy DECIMS
;uwaga: funkcja nieco "na wyrost"! wynik pomiaru nigdy
;       nie przekroczy wartosci 1024 dec. (3FFh)
;-------------------------------------------------------
bin_2_dec
	ld	Y,#6		;zerowanie tablicy DECIMS
	clr	A
	clr	X
bin_2_dec_1
	ld	(decims,X),A
	inc	X
	dec	Y
	jrne	bin_2_dec_1
				;zaladowanie wyniku pomiaru do
	ld	A,vvolts		;komorek SUB_A
	ld	sub_a,A
	ld	A,{vvolts+1}
	ld	{sub_a+1},A
				;liczenie ile razy 10000 miesci sie w liczbie
	ld	A,#$27
	ld	sub_b,A
	ld	A,#$10
	ld	{sub_b+1},A
bin_2_10000
	callr	subw		;odejmowanie SUB_A-SUB_B
	jrc	bin_2_10000_end	;jesli C, to liczba<10000
	inc	decims		;zwiekszenie licznika 10000
	ld	A,roznicaw	;przeniesienie wynku do SUB_A
	ld	sub_a,A
	ld	A,{roznicaw+1}
	ld	{sub_a+1},A
	jra	bin_2_10000	;powtorne odejmowanie 10000

bin_2_10000_end			;liczenie ile razy 1000 miesci sie w liczbie
	ld	A,#3
	ld	sub_b,A
	ld	A,#$E8
	ld	{sub_b+1},A
bin_2_1000
	callr	subw
	jrc	bin_2_1000_end	;jesli C, to liczba<1000
	inc	{decims+1}	;zwiekszenie licznika 1000
	ld	A,roznicaw	;przeniesienie wynku do SUB_A
	ld	sub_a,A
	ld	A,{roznicaw+1}
	ld	{sub_a+1},A
	jra	bin_2_1000	;powtorne odejmowanie 1000

bin_2_1000_end			;liczenie ile razy 100 miesci sie w roznicy
	clr	sub_b
	ld	A,#100
	ld	{sub_b+1},A
bin_2_100
	callr	subw
	jrc	bin_2_100_end	;jesli C, to liczba<100
	inc	{decims+2}	;zwiekszenie licznika 100
	ld	A,roznicaw	;przeniesienie wynku do SUB_A
	ld	sub_a,A
	ld	A,{roznicaw+1}
	ld	{sub_a+1},A
	jra	bin_2_100	;powtorne odejmowanie 100

bin_2_100_end			;liczenie ile razy 10 miesci sie w roznicy
	clr	sub_b
	ld	A,#10
	ld	{sub_b+1},A
bin_2_10
	callr	subw
	jrc	bin_2_10_end	;jesli C, to liczba<10
	inc	{decims+3}	;zwiekszenie licznika 10
	ld	A,roznicaw	;przeniesienie wynku do SUB_A
	ld	sub_a,A
	ld	A,{roznicaw+1}
	ld	{sub_a+1},A
	jra	bin_2_10		;powtorne odejmowanie 10

bin_2_10_end
	ld	A,{sub_a+1}	;pozostalosc po odejmowaniu to jednostki
	ld	{decims+4},A

	ret


;-------------------------------------------------------
; poczatek programu glownego
;-------------------------------------------------------
main
	PORTS_INIT		;inicjalizacja portw I/O
	SPI_INIT			;inicjalizacja trybu pracy SPI
	TIMB_INIT		;inicjalizacja timera B

	clr	X
mloop
	ld	A,#10		;wypelenienie tanlicy ledbuf wzorcem dla
	ld	(ledbuf,X),A	;wylaczenia znakow
	inc	X
	ld	A,X
	cp	A,#6
	jrne	mloop
	rim			;zalaczenie przerwan
mvolt
	call	volts		;pomiar napiecia
	call	bin_2_dec	;konwersja na BCD

	ld	X,#2		;X bedzie indeksem do bufora LED
	clr	Y		;Y bedzie indeksem do bufora konwersji
mmove
	ld	A,(decims,Y)
	ld	(ledbuf,X),A
	inc	X
	inc	Y
	ld	A,X
	cp	A,#6
	jrne	mmove
	jra	mvolt		;wyswietlanie w przerwaniu timera B


;-------------------------------------------------------
; "pusta" funkcja, zawiera tylko instrukcje powrotu
; z obslugi przerwania
;-------------------------------------------------------
.it_ret	iret


	segment 'intvect'
;-------------------------------------------------------
; wektory przerwan
;-------------------------------------------------------
	DC.W	it_ret
	DC.W	it_ret
	DC.W	it_ret
.sci	DC.W	it_ret
.timb	DC.W	timerb
.tima	DC.W	it_ret
.spi	DC.W	it_ret
	DC.W	it_ret
	DC.W	it_ret
.ext3	DC.W	it_ret
.ext2	DC.W	it_ret
.ext1	DC.W	it_ret
.ext0	DC.W	it_ret
	DC.W	it_ret
.soft	DC.W	it_ret
.rst	DC.W	main


	END
