st7/
;Program demonstracyjny demonstrujcy uycie
;wywietlacza LED: 6 znakw 7 segmentowych

	MOTOROLA			;format MOTOROLA (.s19)

	#include "st7flite29.inc"

;segmenty pamici
	BYTES
	segment byte at 80-FF 'ram0'
	segment byte at 100-1FF 'stack'
	segment byte at 200-27F 'ram1'
	segment byte at 1000-10FF 'eeprom'
	segment byte at E000-FFDF 'program'
	segment byte at FFE0-FFFF 'intvect'


	BYTES
;deklaracje zmiennych
	segment 'ram0'
ledcnt	DS.B		;licznik znakw LED
ledbuf	DS.B	6	;miejsce na 6 znakw
leddata	DS.B	2	;biecy wywietlany znak

;deklaracje staych
	WORDS
	segment 'program'

;-------------------------------------------------------
; deklaracje tabel zwizanych z cyframi
;-------------------------------------------------------
sequence	DC.B	$FE,$FD,$FB,$F7,$EF,$DF
patterns	DC.B	%00001001,%10101111,%00011010,%10001010,%10101100 ;0,1,2,3,4,
pat1		DC.B	%11001000,%01001000,%10001111,%00001000,%10001000 ;5,6,7,8,9,
pat2	DC.B	$FF		;znak wyczony


;-------------------------------------------------------
; inicjacja uywanych portw I/O
;port B
PBDR_init	EQU	%00000000
PBDDR_init	EQU	%11111011
PBOR_init	EQU	%11111011
;-------------------------------------------------------
PORTS_INIT MACRO
	ld	A,#PBDDR_init	;nastawa trybu pracy portu B
	ld	PBDDR,A
	ld	A,#PBOR_init
	ld	PBOR,A
	ld	A,#PBDR_init
	ld	PBDR,A
	MEND


;-------------------------------------------------------
; inicjacja SPI:
;   CLK = fcpu/3, divider = wyczony, cpol = idle gdy "H",
;   cpha = 1, przerwania = wyczone, tryb = master
SPISR_init	EQU	%00000011
SPICR_init	EQU	%00011100
SPI_enable	EQU	%01000000
;-------------------------------------------------------
SPI_INIT	MACRO
	ld	A,#SPISR_init
	ld	SPISR,A
	ld	A,#SPICR_init
	ld	SPICR,A
	or	A,#SPI_enable
	ld	SPICR,A
	MEND


;-------------------------------------------------------
; inicjacja timera Lite (timer B)
;-------------------------------------------------------
TIMB_INIT MACRO
	clr	A		;f_CPU = f_OSC
	ld	MCCSR,A
	ld	A,#$12		;f_TIMER = f_CPU
	ld	ATCSR,A
        	clr	A		;konfiguracja 12-bitowego timera
	ld	ATRL,A
	ld	A,#$07
	ld	ATRH,A
	clr	ledcnt		;zerowanie licznika znakw
	MEND


;-------------------------------------------------------
; funkcja obsugi przerwania timera B
;-------------------------------------------------------
timerb
	ld	A,ledcnt
	sub	A,#6			;C=1 dla licznika <= 6
	jrc	timbskip
	clr	ledcnt		;jeli licznik > 5,to zerowanie
timbskip
	ld	X,ledcnt		;zaadowanie wzorca zaczenia klucza 
					;tranzystorowego
	ld	A,(sequence,X)	;na podstawie wartoci licznika
	ld	leddata,A
	ld	A,(ledbuf,X)	;pobranie cyfry BCD do akumulatora
	ld	X,A			;ustawienie rejestru indeksowego
	ld	A,(patterns,X)	;pobranie wzorca cyfry
	ld	{leddata+1},A	;zaadowanie wzorca cyfry do bufora biecej cyfry
	call	ledwrite		;wysanie znakw do rejestrw cyfr
	inc	ledcnt
	ld	A,ATCSR		;odczyt ATCSR w celu zerowania flagi przerwania
	iret


;-------------------------------------------------------
; funkcja wysyajca zmienn LEDDATA do wywietlacza LED
;-------------------------------------------------------
ledwrite
	push	X			;zapamitanie modyfikowanych rejestrw
	push	A
	clr	X
	ld	A,(leddata,X)	;pierwszy bajt zmiennej
	ld	SPIDR,A
	btjf	SPISR,#7,*		;oczekiwanie na wysanie bajtu
	ld	A,SPIDR		;dla wyzerowania SPIF
	inc	X			;drugi bajt zmiennej
	ld	A,(leddata,X)
	ld	SPIDR,A
	btjf	SPISR,#7,*		;oczekiwanie na wysanie bajtu
	ld	A,SPIDR		;dla wyzerowania SPIF
	ld	A,PBDR		;krtki impuls dodatni na PB4
	or	A,#$10
	ld	PBDR,A
	and	A,#$EF
	ld	PBDR,A
	pop	A			;odtworzenie rejestrw roboczych
	pop	X
	ret


;-------------------------------------------------------
; pocztek programu gwnego
;-------------------------------------------------------
main
	PORTS_INIT			;inicjalizacja portw I/O
	SPI_INIT				;inicjalizacja trybu pracy SPI
	TIMB_INIT			;inicjalizacja timera B
	ld	A,#0			;umieszczenie w buforze cigu 012345
	ld	{ledbuf+0},A
	ld	A,#1
	ld	{ledbuf+1},A
	ld	A,#2
	ld	{ledbuf+2},A
	ld	A,#3
	ld	{ledbuf+3},A
	ld	A,#4
	ld	{ledbuf+4},A
	ld	A,#5
	ld	{ledbuf+5},A

	rim				;zaczenie przerwa
	jra	*			;wywietlanie w przerwaniu timera B


;-------------------------------------------------------
; "pusta" funkcja, zawiera tylko instrukcje powrotu
; z obsugi przerwania
;-------------------------------------------------------
.it_ret	iret


	segment 'intvect'
;-------------------------------------------------------
; wektory przerwa
;-------------------------------------------------------
	DC.W	it_ret
	DC.W	it_ret
	DC.W	it_ret
.sci	DC.W	it_ret
.timb	DC.W	timerb
.tima	DC.W	it_ret
.spi	DC.W	it_ret
	DC.W	it_ret
	DC.W	it_ret
.ext3	DC.W	it_ret
.ext2	DC.W	it_ret
.ext1	DC.W	it_ret
.ext0	DC.W	it_ret
	DC.W	it_ret
.soft	DC.W	it_ret
.rst	DC.W	main

	END
